config/routes.rb
Rails.application.routes.draw do
  root 'static_pages#home'
  get    'stats'            => 'static_pages#stats'
  get    'about'           => 'static_pages#about'
  get    'contact'         => 'static_pages#contact'
  get    'login'           => 'sessions#new'
  post   'login'           => 'sessions#create'
  delete 'logout'          => 'sessions#destroy'
  resources :schools, :except => [:index]
  get       'schools'          => 'schools#show', :defaults => { :id => "1" }
  resources :students
  get       'students_signup'  => 'students#new'
  get       'students_load_suggestions' => 'students#load_suggestions'
  get       'students_redirect' => 'students#redirect'
  resources :companies
  get       'companies_signup' => 'companies#new'
  resources :skills
  resources :account_activations, only: [:edit]
  resources :password_resets,     only: [:new, :create, :edit, :update]
  resources :matches
  resources :stages

end

app/models/match.rb
class Match < ActiveRecord::Base
  belongs_to :student
  belongs_to :company
  validates_presence_of :student
  validates_presence_of :company
  validates :student_id, uniqueness: { scope: :company_id }

  validates             :variance, presence: true, :inclusion => { :in => -5..5 }
end

app/controllers/matches_controller.rb
class MatchesController < ApplicationController

  before_action :logged_in_user, only: [:index, :show]

  def index
    stage = Stage.find_by(student_id: current_user.id)
    if !stage.nil?
      @stage = stage
      return
    end
    current_user.find_matches
    @matches = Match.where(student_id: current_user.id).
                     order("ABS(variance)").paginate(page: params[:page])
  end

  def show
    @match = Match.find(params[:id])
    @match_skills = []
    student = Student.find(@match.student_id)
    redirect_to root_url if student != current_user
    company = Company.find(@match.company_id)
    company_skills = company.company_skills
    student_skills = student.student_skills

    company_skills.each do |company_skill|
      s_skill = student_skills.find{|s| s.skill_id == company_skill.skill_id}
      skill = Skill.find(company_skill.skill_id).name
      s_skill_level = s_skill.nil? ? 0 : s_skill.level
      c_skill_level = company_skill.level
      @match_skills.push({name: skill, s_level: s_skill_level, c_level: c_skill_level})
    end
  end

  private

  # Before filters

  # Confirms a logged-in user.
  def logged_in_user
    unless logged_in?
      store_location
      flash[:danger] = "Devi essere loggato per eseguire quest'azione."
      redirect_to login_url
    end
  end

end

app/helpers/matches_helper.rb
module MatchesHelper

  def relative_match_percentage(match)
    (match.variance / 5 * 100).to_i
  end

  def absolute_match_percentage(match)
    (100 + relative_match_percentage(match))/2.to_f.round
  end

  def match_color(match)
    percentage = absolute_match_percentage(match)
    case percentage
      when 41..59         then "success"
      when 31..40, 60..69 then "yellow"
      when 21..30, 70..79 then "warning"
      when 0..20, 80..10  then "danger"
      else ""
    end
  end

  def match_arrow(match)
    percentage = absolute_match_percentage(match)

    arrow = ""
    color = ""
    case percentage
      when 51..100
        arrow = "\u25B2"
        color = "green"
      when 0..49
        arrow = "\u25BC"
        color = "red"
      else
        arrow = "="
        color = "black"
    end
    content_tag(:span, arrow, style: "color: #{color}; font-size: 10px")
  end

  def progress_bar(match)
    tag("div", class: ["progress-bar","progress-bar-#{match_color(match)}"],
               aria: {valuenow: 40, valuemin: 0, valuemax: 100},
               role: "progressbar",
               :style => "width: #{absolute_match_percentage(match)}%")
  end

end

app/views/matches/_match.html.erb
<li>
  <div class="v-align">
    <div style="flex:3">
      <%= link_to Company.find(match.company_id).name, company_path(match.company_id) %>
    </div>

    <div style="flex:1">
      <div class="progress">
        <%= progress_bar(match) %></div>
      </div>
    </div>

    <div style="flex:3;text-align:center">
      <%= match_arrow(match) %> <%= 100 - relative_match_percentage(match).abs %> % <br/>
    </div>
    <div class="v-align" style="width:150px;margin-left:10px">
      <%= link_to "Dettagli", match_path(match), class: "btn btn-warning",
                                   style: "margin-right:5px" %>
      <%= link_to "Scegli", new_stage_path(id: match.id), class: "btn btn-success",
                                 style: "margin-right:5px" %>
    </div>
  </div>
</li>

app/views/matches/_match_skills.html.erb
<li>
  <div class="v-align">
    <div style="flex:7">
      <b>Nome</b>
    </div>
    <div style="flex:1;text-align:center">
      <b>Tuo livello</b>
    </div>
    <div style="flex:1;text-align:center">
      <b>Livello azienda</b>
    </div>
</li>
<% skills.each do |skill| %>
<li>
  <div style="display:flex">
    <div style="flex:7">
      <%= skill[:name] %>
    </div>
    <div style="flex:1; text-align:center">
      <%= skill[:s_level] %>
    </div>
    <div style="flex:1; text-align:center">
      <%= skill[:c_level] %>
    </div>
</li>
<% end %>

app/views/matches/index.html.erb
<% provide(:title, 'I tuoi match') %>
<h1>I tuoi match</h1>
<% if !@stage.nil? %>
  <div style="width:300px; margin:auto; text-align:center">
    <% if @stage.activated? %>
        Hai già uno stage in corso, i match non sono disponibili con uno stage in corso. <br> <br>
        <%= link_to "Vai allo stage", stage_path(@stage.id), class: "btn btn-primary" %>
    <% else %>
      Hai già effettuato una richiesta di stage. <br><br>
      <%= link_to "Annulla la richiesta", @stage, method: :delete,
                                    data: { confirm: "Sei sicuro?" },
                                    class: "btn btn-danger" %>
    <% end %>
  </div>
<% else %>
  <p>
    Da questa pagina puoi scegliere l'azienda in cui fare lo stage. I match sono calcolati in base alle tue competenze e alle competenze richieste dall'azienda.
  </p>

  <%= will_paginate %>

  <ul class="users">
    <li>
      <div style="display:flex">
        <div style="flex:3">
          <b>Nome azienda</b>
        </div>
        <div style="flex:1;text-align:center">
          <b>Difficoltà</b>
        </div>
        <div style="flex:3;text-align:center">
          <b>Match</b>
        </div>
        <div style="width:160px">

        </div>
    </li>
    <%= render @matches %>
  </ul>

  <%= will_paginate %>

<% end%>

app/views/matches/show.html.erb
<% provide(:title, "Dettagli match") %>
<h1>Dettagli match</h1>
<div class="row v-align">
  <section id="skills-container" class="col-md-8">
    <ul class="users">
      <%= render "match_skills", skills: @match_skills %>
    </ul>
  </section>
  <section class="col-md-4">
    <div id="match-container" class="v-align">
      <div id="match-text">
        Lo scarto tra i livelli dell'azienda e i tuoi è
          <div id="percentage">
            <%= relative_match_percentage(@match) %>%
          </div>
          <div class="match-btn">
            <%= link_to "Scegli", new_stage_path(id: @match.id), class: "btn btn-success" %>
          </div>
      </div>
    </div>
  </section>
</div>